EXTENDED LIGHTS OUT (高斯消元)
The aim of the game is, starting from any initial set of
lights on in the display, to press buttons to get the display to a state
where all lights are off. When adjacent buttons are pressed, the action
of one button can undo the effect of another. For instance, in the
display below, pressing buttons marked X in the left display results in
the right display.Note that the buttons in row 2 column 3 and row 2
column 5 both change the state of the button in row 2 column 4,so that,
in the end, its state is unchanged.
Note:
1. It does not matter what order the buttons are pressed.
2. If a button is pressed a second time, it exactly cancels
the effect of the first press, so no button ever need be pressed more
than once.
3. As illustrated in the second diagram, all the lights in
the first row may be turned off, by pressing the corresponding buttons
in the second row. By repeating this process in each row, all the lights
in the first
four rows may be turned out. Similarly, by pressing buttons
in columns 2, 3 ?, all lights in the first 5 columns may be turned off.
Write a program to solve the puzzle.
Input
number of puzzles that follow. Each puzzle will be five lines, each of
which has six 0 or 1 separated by one or more spaces. A 0 indicates that
the light is off, while a 1 indicates that the light is on initially.
Output
"PUZZLE #m", where m is the index of the puzzle in the input file.
Following that line, is a puzzle-like display (in the same format as the
input) . In this case, 1's indicate buttons that must be pressed to
solve the puzzle, while 0 indicate buttons, which are not pressed. There
should be exactly one space between each 0 or 1 in the output
puzzle-like display.
Sample Input
- 2
- 0 1 1 0 1 0
- 1 0 0 1 1 1
- 0 0 1 0 0 1
- 1 0 0 1 0 1
- 0 1 1 1 0 0
- 0 0 1 0 1 0
- 1 0 1 0 1 1
- 0 0 1 0 1 1
- 1 0 1 1 0 0
- 0 1 0 1 0 0
Sample Output
- PUZZLE #1
- 1 0 1 0 0 1
- 1 1 0 1 0 1
- 0 0 1 0 1 1
- 1 0 0 1 0 0
- 0 1 0 0 0 0
- PUZZLE #2
- 1 0 0 1 1 1
- 1 1 0 0 0 0
- 0 0 0 1 0 0
- 1 1 0 1 0 1
- 1 0 1 1 0 1
- 大佬博客 : https://blog.csdn.net/FromATP/article/details/53966305
- #include<cstdio>
- #include<cstring>
- #include<algorithm>
- #include<iostream>
- #include<string>
- #include<vector>
- #include<stack>
- #include<bitset>
- #include<cstdlib>
- #include<cmath>
- #include<set>
- #include<list>
- #include<deque>
- #include<map>
- #include<queue>
- using namespace std;
- typedef long long lint;
- const double PI = acos(-1.0);
- const int INF = ;
- const int maxn = ;
- // 暴力枚举 :
- /*
- int mp[20][20], cal[20][20], vis[20][20];
- int n, m;
- int dr[5][2] = { {0,1}, {0,-1}, {1,0}, {-1,0}, {0,0} };
- int mi = INF;
- int fz(int x, int y)
- {
- int t = mp[x][y];
- for(int i = 0; i< 5; i++)
- {
- int xx = x + dr[i][0];
- int yy = y + dr[i][1];
- if(xx <= n && xx > 0 && yy <= m && yy >0)
- t += vis[xx][yy];
- }
- return t%2;
- }
- int dfs()
- {
- for(int j = 2; j <= n; j++)
- for(int k = 1; k <= m; k++)
- {
- if(fz(j-1, k)) vis[j][k] = 1;
- }
- for(int j = 1; j <= m; j++)
- {
- if(fz(n, j))
- return -1;
- }
- int cnt = 0;
- for(int i = 1; i <= n; i++)
- for(int j = 1; j <= m; j++)
- cnt += vis[i][j];
- return cnt;
- }
- int main()
- {
- ios::sync_with_stdio(false);
- int T;
- cin >> T;
- int ans = 0;
- while(ans++ < T)
- {
- mi = INF;
- n = 5;
- m = 6;
- for(int i = 1; i <=n; i++)
- for(int j = 1; j <=m ; j++)
- cin >> mp[i][j];
- int flag = 0;
- for(int i = 0; i < 1<<m ; i++)
- {
- memset(vis, 0, sizeof(vis));
- for(int j = 1; j <= m; j++)
- vis[1][m-j+1] = i>>(j-1) & 1;
- int cnt = dfs();
- if(cnt < mi && cnt >= 0)
- {
- flag =1;
- mi = cnt;
- memcpy(cal, vis, sizeof(vis));
- }
- }
- cout << "PUZZLE #" << ans << endl;
- if(flag)
- {
- for(int i = 1; i <=n; i++)
- {
- for(int j = 1; j <= m; j++)
- {
- if(j != 1) cout << " ";
- cout << cal[i][j];
- }
- cout << endl;
- }
- }
- else cout << "IMPOSSIBLE" << endl;
- }
- return 0;
- }
- */
- // 高斯消元法 :
- #include<cstdio>
- #include<algorithm>
- #include<cstring>
- using namespace std;
- const int n=;
- int tt,a[n+][n+];
- void gauss()//保证有解
- {
- int r;
- for(int i=;i<=n;i++)
- {
- for(int j=i;j<=n;j++)if(a[j][i]){r=j;break;}
- if(r!=i)for(int j=;j<=n+;j++) swap(a[i][j],a[r][j]);
- for(int j=i+;j<=n;j++)if(a[j][i])
- for(int k=i;k<=n+;k++)
- a[j][k]^=a[i][k];
- }
- for(int i=n;i>=;i--)
- for(int j=i+;j<=n;j++)
- if(a[i][j])a[i][n+]^=a[j][n+];
- }
- int main()
- {
- scanf("%d",&tt);
- int t=;
- while(tt--)
- {
- t++;
- memset(a,,sizeof(a));
- for(int i=;i<=n;i++)
- {
- scanf("%d",&a[i][n+]);
- a[i][i]=;
- if(i%!=)a[i][i-]=;
- if(i%!=)a[i][i+]=;
- if(i>)a[i][i-]=;
- if(i<)a[i][i+]=;
- }
- gauss();
- printf("PUZZLE #%d\n",t);
- for(int i=;i<=n;i++)
- {
- if(!(i%))printf("%d\n",a[i][n+]);
- else printf("%d ",a[i][n+]);
- }
- }
- return ;
- }
EXTENDED LIGHTS OUT (高斯消元)的更多相关文章
- poj1222 EXTENDED LIGHTS OUT 高斯消元||枚举
Time Limit: 1000MS Memory Limit: 10000K Total Submissions: 8481 Accepted: 5479 Description In an ...
- POJ 1222 EXTENDED LIGHTS OUT (高斯消元)
题目链接 题意:5*6矩阵中有30个灯,操作一个灯,周围的上下左右四个灯会发生相应变化 即由灭变亮,由亮变灭,如何操作使灯全灭? 题解:这个问题是很经典的高斯消元问题.同一个按钮最多只能被按一次,因为 ...
- POJ1222 EXTENDED LIGHTS OUT 高斯消元 XOR方程组
http://poj.org/problem?id=1222 在学校oj用搜索写了一次,这次写高斯消元,haoi现场裸xor方程消元没写出来,真实zz. #include<iostream> ...
- [poj1222]EXTENDED LIGHTS OUT(高斯消元)
题意:每个灯开启会使自身和周围的灯反转,要使全图的灯灭掉,判断灯开的位置. 解题关键:二进制高斯消元模板题. 复杂度:$O({n^3})$ #include<cstdio> #includ ...
- POJ 1222 EXTENDED LIGHTS OUT [高斯消元XOR]
题意: $5*6$网格里有一些灯告诉你一开始开关状态,按一盏灯会改变它及其上下左右的状态,问最后全熄灭需要按那些灯,保证有解 经典问题 一盏灯最多会被按一次,并且有很明显的异或性质 一个灯作为一个方程 ...
- BZOJ 1770: [Usaco2009 Nov]lights 燈( 高斯消元 )
高斯消元解xor方程组...暴搜自由元+最优性剪枝 -------------------------------------------------------------------------- ...
- BZOJ1770:[USACO]lights 燈(高斯消元,DFS)
Description 貝希和她的閨密們在她們的牛棚中玩遊戲.但是天不從人願,突然,牛棚的電源跳閘了,所有的燈都被關閉了.貝希是一個很膽小的女生,在伸手不見拇指的無盡的黑暗中,她感到驚恐,痛苦與絕望. ...
- [luoguP2962] [USACO09NOV]灯Lights(高斯消元 + dfs)
传送门 先进行高斯消元 因为要求最少的开关次数,那么: 对于关键元,我们可以通过带入消元求出, 对于自由元,我们暴力枚举,进行dfs,因为只有开关两种状态,0或1 #include <cmath ...
- BZOJ 1770: [Usaco2009 Nov]lights 燈 [高斯消元XOR 搜索]
题意: 经典灯问题,求最少次数 本题数据不水,必须要暴搜自由元的取值啦 想了好久 然而我看到网上的程序都没有用记录now的做法,那样做遇到自由元应该可能会丢解吧...? 我的做法是把自由元保存下来,枚 ...
随机推荐
- LeetCode 762 Prime Number of Set Bits in Binary Representation 解题报告
题目要求 Given two integers L and R, find the count of numbers in the range [L, R] (inclusive) having a ...
- appium入门(1)__ appium介绍
摘自:http://www.testclass.net/appium/appium-base-summary/ 1.特点 appium 是一个自动化测试开源工具,支持 iOS 平台和 Android ...
- SQL Server的一些小问题
一.SQL Server远程调用失败 解决办法:在控制面板-程序和功能中卸载“Microsoft SQL Server 2012 Express LocalDB”,具体版本根据你安装的VS版本决定,我 ...
- 实现简单的 u-boot
根据u-boot-1.1.6启动流程来划分,u-boot功能主要划分为四个部分 1,硬件初始化 -->start.S init.c 2,从 fla ...
- nodejs 学习三 异步和同步
同步函数 for (let i = 0; i < 10; i ++) { setTimeout(() => { console.log(`${i} ______ ${new Date}`) ...
- 1、 LwIP协议栈规范翻译——简介
1.简介 在过去几年中,计算机和计算机支持设备接之间的互联到无线网络日趋增加.计算机已经越来越无缝的集成在了日常的设备且价格也在下降.同时,无线网络技术例如蓝牙[HNI+98]和IEEE802.11b ...
- MySQL复制异常大扫盲:快速溯源与排查错误全解
MySQL复制异常大扫盲:快速溯源与排查错误全解https://mp.weixin.qq.com/s/0Ic8BnUokyOj7m1YOrk1tA 作者介绍王松磊,现任职于UCloud,从事MySQL ...
- 20180310 KindEditor 富文本编辑器
问题: 如何判断富文本编辑器文本内容非空 错误的办法,采用js 对控件本身的txt ID 号抓取获取值,由于加载富文本编辑器时,界面的ID 已经经过了修改或者可以用转换来说,所以抓取是无效果的. 需要 ...
- 浅谈JS的变量提升
JS的解析机制,是JS的又一大重点知识点,在面试题中更经常出现,今天就来唠唠他们的原理.首先呢,我们在我们伟大的浏览器中,有个叫做JS解析器的东西,它专门用来读取JS,执行JS.一般情况是存在作用域就 ...
- error: Microsoft Visual C++ 14.0 is required(line_profiler模块安装失败的解决办法)
一.我的安装环境: 1.系统:win10,64位 2.python版本:python3.6.4 二.遇到的问题: 1.cmd黑屏终端下输入命令:pip install line_profiler(安装 ...